crypton-1.0.1: Cryptography Primitives sink

License | BSD-style
Maintainer | Carlos Rodriguez-Vega <crodveg@yahoo.es>
Stability | experimental
Portability | unknown
Safe Haskell | None
Language | Haskell2010

Crypto.PubKey.Rabin.Basic

Description

Rabin cryptosystem for public-key cryptography and digital signature.

Synopsis

- data PublicKey = PublicKey {
  - public_size :: Int
  - public_n :: Integer
  }
- data PrivateKey = PrivateKey {
  - private_pub :: PublicKey
  - private_p :: Integer
  - private_q :: Integer
  - private_a :: Integer
  - private_b :: Integer
  }
- data Signature = Signature (Integer, Integer)
- generate :: MonadRandom m => Int -> m (PublicKey, PrivateKey)
- encrypt :: (HashAlgorithm hash, MonadRandom m) => OAEPParams hash ByteString ByteString -> PublicKey -> ByteString -> m (Either Error ByteString)
- encryptWithSeed :: HashAlgorithm hash => ByteString -> OAEPParams hash ByteString ByteString -> PublicKey -> ByteString -> Either Error ByteString
- decrypt :: HashAlgorithm hash => OAEPParams hash ByteString ByteString -> PrivateKey -> ByteString -> Maybe ByteString
- sign :: (MonadRandom m, HashAlgorithm hash) => PrivateKey -> hash -> ByteString -> m (Either Error Signature)
- signWith :: HashAlgorithm hash => ByteString -> PrivateKey -> hash -> ByteString -> Either Error Signature
- verify :: HashAlgorithm hash => PublicKey -> hash -> ByteString -> Signature -> Bool

# Documentation

data PublicKey #

Represent a Rabin public key.

Constructors

PublicKey |

Fields

- public_size :: Int

  size of key in bytes

- public_n :: Integer

  public p*q

#### Instances

Instances details

Data PublicKey # |

Instance details

Defined in Crypto.PubKey.Rabin.Basic

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> PublicKey -> c PublicKey #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c PublicKey #

toConstr :: PublicKey -> Constr #

dataTypeOf :: PublicKey -> DataType #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c PublicKey) #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c PublicKey) #

gmapT :: (forall b. Data b => b -> b) -> PublicKey -> PublicKey #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> PublicKey -> r #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> PublicKey -> r #

gmapQ :: (forall d. Data d => d -> u) -> PublicKey -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> PublicKey -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> PublicKey -> m PublicKey #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> PublicKey -> m PublicKey #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> PublicKey -> m PublicKey #

Read PublicKey # |
Instance details Defined in Crypto.PubKey.Rabin.Basic Methods readsPrec :: Int -> ReadS PublicKey # readList :: ReadS [PublicKey] # readPrec :: ReadPrec PublicKey # readListPrec :: ReadPrec [PublicKey] #
Show PublicKey # |
Instance details Defined in Crypto.PubKey.Rabin.Basic Methods showsPrec :: Int -> PublicKey -> ShowS # show :: PublicKey -> String # showList :: [PublicKey] -> ShowS #
Eq PublicKey # |
Instance details Defined in Crypto.PubKey.Rabin.Basic Methods (==) :: PublicKey -> PublicKey -> Bool # (/=) :: PublicKey -> PublicKey -> Bool #

data PrivateKey #

Represent a Rabin private key.

Constructors

PrivateKey |

Fields

- private_pub :: PublicKey
- private_p :: Integer

  p prime number

- private_q :: Integer

  q prime number

- private_a :: Integer
- private_b :: Integer

#### Instances

Instances details

Data PrivateKey # |

Instance details

Defined in Crypto.PubKey.Rabin.Basic

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> PrivateKey -> c PrivateKey #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c PrivateKey #

toConstr :: PrivateKey -> Constr #

dataTypeOf :: PrivateKey -> DataType #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c PrivateKey) #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c PrivateKey) #

gmapT :: (forall b. Data b => b -> b) -> PrivateKey -> PrivateKey #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> PrivateKey -> r #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> PrivateKey -> r #

gmapQ :: (forall d. Data d => d -> u) -> PrivateKey -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> PrivateKey -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> PrivateKey -> m PrivateKey #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> PrivateKey -> m PrivateKey #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> PrivateKey -> m PrivateKey #

Read PrivateKey # |
Instance details Defined in Crypto.PubKey.Rabin.Basic Methods readsPrec :: Int -> ReadS PrivateKey # readList :: ReadS [PrivateKey] # readPrec :: ReadPrec PrivateKey # readListPrec :: ReadPrec [PrivateKey] #
Show PrivateKey # |
Instance details Defined in Crypto.PubKey.Rabin.Basic Methods showsPrec :: Int -> PrivateKey -> ShowS # show :: PrivateKey -> String # showList :: [PrivateKey] -> ShowS #
Eq PrivateKey # |
Instance details Defined in Crypto.PubKey.Rabin.Basic Methods (==) :: PrivateKey -> PrivateKey -> Bool # (/=) :: PrivateKey -> PrivateKey -> Bool #

data Signature #

Rabin Signature.

Constructors

Signature (Integer, Integer) |

#### Instances

Instances details

Data Signature # |

Instance details

Defined in Crypto.PubKey.Rabin.Basic

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> Signature -> c Signature #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c Signature #

toConstr :: Signature -> Constr #

dataTypeOf :: Signature -> DataType #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c Signature) #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c Signature) #

gmapT :: (forall b. Data b => b -> b) -> Signature -> Signature #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> Signature -> r #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> Signature -> r #

gmapQ :: (forall d. Data d => d -> u) -> Signature -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> Signature -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> Signature -> m Signature #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> Signature -> m Signature #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> Signature -> m Signature #

Read Signature # |
Instance details Defined in Crypto.PubKey.Rabin.Basic Methods readsPrec :: Int -> ReadS Signature # readList :: ReadS [Signature] # readPrec :: ReadPrec Signature # readListPrec :: ReadPrec [Signature] #
Show Signature # |
Instance details Defined in Crypto.PubKey.Rabin.Basic Methods showsPrec :: Int -> Signature -> ShowS # show :: Signature -> String # showList :: [Signature] -> ShowS #
Eq Signature # |
Instance details Defined in Crypto.PubKey.Rabin.Basic Methods (==) :: Signature -> Signature -> Bool # (/=) :: Signature -> Signature -> Bool #

generate :: MonadRandom m => Int -> m (PublicKey, PrivateKey) #

Generate a pair of (private, public) key of size in bytes. Primes p and q are both congruent 3 mod 4.

See algorithm 8.11 in "Handbook of Applied Cryptography" by Alfred J. Menezes et al.

encrypt #

Arguments

:: (HashAlgorithm hash, MonadRandom m) |
=> OAEPParams hash ByteString ByteString | OAEP padding parameters
-> PublicKey | public key
-> ByteString | plaintext
-> m (Either Error ByteString) |

Encrypt plaintext using public key.

encryptWithSeed #

Arguments

:: HashAlgorithm hash |
=> ByteString | Seed
-> OAEPParams hash ByteString ByteString | OAEP padding
-> PublicKey | public key
-> ByteString | plaintext
-> Either Error ByteString |

Encrypt plaintext using public key an a predefined OAEP seed.

See algorithm 8.11 in "Handbook of Applied Cryptography" by Alfred J. Menezes et al.

decrypt #

Arguments

:: HashAlgorithm hash |
=> OAEPParams hash ByteString ByteString | OAEP padding parameters
-> PrivateKey | private key
-> ByteString | ciphertext
-> Maybe ByteString |

Decrypt ciphertext using private key.

See algorithm 8.12 in "Handbook of Applied Cryptography" by Alfred J. Menezes et al.

sign #

Arguments

:: (MonadRandom m, HashAlgorithm hash) |
=> PrivateKey | private key
-> hash | hash function
-> ByteString | message to sign
-> m (Either Error Signature) |

Sign message using hash algorithm and private key.

See https://en.wikipedia.org/wiki/Rabin_signature_algorithm.

signWith #

Arguments

:: HashAlgorithm hash |
=> ByteString | padding
-> PrivateKey | private key
-> hash | hash function
-> ByteString | message to sign
-> Either Error Signature |

Sign message using padding, hash algorithm and private key.

See https://en.wikipedia.org/wiki/Rabin_signature_algorithm.

verify #

Arguments

:: HashAlgorithm hash |
=> PublicKey | private key
-> hash | hash function
-> ByteString | message
-> Signature | signature
-> Bool |

Verify signature using hash algorithm and public key.

See https://en.wikipedia.org/wiki/Rabin_signature_algorithm.